package TEST2;

import java.util.*;
import java.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import javax.microedition.io.*;


public class TSP extends MIDlet implements CommandListener{
  
   boolean isStandalone = false;
  TextField textc = new TextField("points", "10", 15, TextField.NUMERIC);
  TextField textp = new TextField("population", "200", 15, TextField.NUMERIC);
  TextField textcr = new TextField("crossover rate(%)", "80", 15, TextField.NUMERIC);
  TextField textm = new TextField("mutation rate(%)", "2", 15, TextField.NUMERIC);
  TextField texti = new TextField("interval", "10", 15, TextField.NUMERIC);
  TextField textg = new TextField("generation", "200", 15, TextField.NUMERIC);
  Command button1 = new Command("Initial",Command.SCREEN,1);
  Command button2 = new Command("Generate",Command.SCREEN,2);
  Command button3 = new Command("Back",Command.SCREEN,3);  
  Form Canv = new Form("TSP");
  Display disp;

  //Thread t;
  //public Evolution Test;
  public DrawCity CityCanvas;
  boolean cityexist,Draw_Line,flag;
  String ball;

  int population;
  int TG;
  int CR;
  int MR;
  int cityNum;
  int Int;
  int CityOrder[][];
  StreamConnection conn=null;
  OutputStream out=null;
  InputStream in=null;
  DataOutputStream dos=null;
  DataInputStream  dis=null;
  
  /**Construct the applet*/
  public TSP() 
  {    
     try 
     {
      disp = Display.getDisplay(this);
      cityexist = false;
      Draw_Line = false;
      CityCanvas = new DrawCity(this);
    }
    catch(Exception e) 
    {
      e.printStackTrace();
    }
  }  
  public void pauseApp() 
  {
  }
  public void destroyApp(boolean unconditional) 
  {
  	textc = null;
  	textp = null;
  	textcr = null;
  	textm = null;
  	texti = null;
  	textg = null;
  	button1 = null;
  	button2 = null;
  	disp.setCurrent(null);
  }  

   public void startApp()
   {
   	Canv.append(textc);
   	Canv.append(textp);
   	Canv.append(textg);
   	Canv.append(textcr);
   	Canv.append(textm);
   	Canv.append(texti);
   	Canv.addCommand(button1);
   	Canv.setCommandListener(this);
    	CityCanvas.addCommand(button2);
    	CityCanvas.addCommand(button3);
    	CityCanvas.setCommandListener(this);    	
   	disp.getDisplay(this).setCurrent(Canv);
   }
  /**Initialize the applet*/
//  public void init() {

  //}


  /**Get Applet information*/
  public String getAppletInfo() {
    return "Applet Information";
  }

  /**Get parameter info*/
  public String[][] getParameterInfo() {
    return null;
  }
  public void commandAction(Command c, Displayable s) {
  	if(c==button1)
  	{
  		button1_mouseClicked();
  	}
  	else
  	{
  		if(c==button2)
  		{
  			button2_mouseClicked();
  		}
  		else
  		{
  			if(c==button3)
  			{
	  			disp.setCurrent(Canv);
  			}  			
  		}
  	}
  }
  void button1_mouseClicked(){
  	//ˬdd
    population=Integer.parseInt(textp.getString());
    if(population>5000) population=5000;
    if(population<1) population=1;

    cityNum=Integer.parseInt(textc.getString());
    if (cityNum>100) cityNum =100;
    if (cityNum<1) cityNum=1;

    TG=Integer.parseInt(textg.getString());
    if(TG>5000) TG=5000;
    if(TG<1) TG=1;

    CR=Integer.parseInt(textcr.getString());
    if(CR>=100) CR=100;
    if(CR<=0) CR=0;

    MR=Integer.parseInt(textm.getString());
    if(MR>=100) MR=100;
    if(MR<=0) MR=0;

    Int=Integer.parseInt(texti.getString());
    cityexist=true;
    Draw_Line=false;
    CityOrder=new int[cityNum+1][];
    for(int i=0;i<CityOrder.length;i++)
       CityOrder[i]=new int[2];
    
    //su
    try{   
    	conn = (StreamConnection)Connector.open("socket://127.0.0.1:4444");
    	out = conn.openOutputStream();
    	in = conn.openInputStream();
    	dos= new DataOutputStream(out);
    	dis= new DataInputStream(in);
    	System.out.print("test");
    	
    	dos.writeInt(CityCanvas.getHeight());
    	dos.writeInt(CityCanvas.getWidth());
    	dos.writeInt(population);   
    	dos.writeInt(TG);
    	dos.writeInt(MR);
    	dos.writeInt(CR);
    	dos.writeInt(cityNum);
    	dos.writeInt(Int);
        
    	for(int i=0;i<cityNum;i++)
    	{
    	   CityOrder[i][0]=dis.readInt();
	   CityOrder[i][1]=dis.readInt();
    	}
    }
    catch(IOException e)
    {
    	System.out.println("IOException " + e);
        e.printStackTrace();
        return;
    }             
    disp.setCurrent(CityCanvas);   
  }

  void button2_mouseClicked() {
  //p
     Draw_Line=true;
     int RecieveTimes=(TG-1)/Int+1;
     try{
       dos.writeBoolean(true);
       for(int i=0;i<RecieveTimes;i++)
       {
          for(int j=0;j<=cityNum;j++)
    	  {
             CityOrder[j][0]=dis.readInt();
	     CityOrder[j][1]=dis.readInt();
          }
          CityCanvas.repaint();
          CityCanvas.serviceRepaints() ;
          dos.writeInt(0);
       }
       dos.close();
       dis.close();
       conn.close();
     }
     catch(IOException e)
     {
     	System.out.println("IOException " + e);
        e.printStackTrace();
     }
  }

  public void Delay(int t){
  try { Thread.sleep(t); }catch(Exception e){}
  }
}

