package TEST;

import java.util.*;
import java.io.*;
//import javax.microedition.lcdui.*;
//import javax.microedition.midlet.*;  

//TSP
public class Evolution
{
   public Evolution()
   {
   }
   
   class DNA {
      public int DNACode[];  //|
      public int SortNum; //`|
      public int ChosenRank; //fitness
      public DNA(int a,int b)
      {
         DNACode=new int[GenLength];
         SortNum=a;
	 ChosenRank=b;
      }
   }
   //cityy
   class CityXY {
      public int x;
      public int y;
      public CityXY(int a,int b)
      {x=a; y=b;}
      public CityXY()
      {}
   }   
   //ΨӲH|class
   class path {
      public int Num;
      public int path;
      public path(int a,int b)
      {Num=a; path=b;}
   }
   
   int height,width;
   int GenLength; //]
   int PointNum;  //ƥ
   Random r=new Random();
   int distance[][]; //Ztable
   DNA population[];    //˥N
   DNA sons[];         //lN
   DNA Ttemp[];         //selectɥΪtemp
   CityXY city[];      //
   int MRate, CrossRate; //ܲv ,tv
   int   TGeneration,SNum,PNum,MAX; //tƥN, sonƥ,populationƥ, Ҧ˥N`|X
   int ftable[];//tΪtable
   int mtable[];
   
   //NtypeDNAB copy A
   public void copy(DNA a,DNA b)
   {
      for(int i=1;i<PointNum;i++)
         a.DNACode[i]=b.DNACode[i];

      a.SortNum=b.SortNum;
   }
   
   //l
   public void Initial(int Num,int g,int m,int c,int city,int h,int w)
   {
      height=h;
      width=w;
      PointNum=city;
      GenLength=city+1;
      PNum=Num;
      TGeneration=g;
      MRate=m;
      CrossRate=c;
      SNum=PNum*CrossRate/100;
      ftable=new int[PointNum];
      mtable=new int[PointNum];

      distance=new int[PointNum][PointNum];
      population=new DNA[PNum];
      sons=new DNA[SNum];
      Ttemp=new DNA[PNum];
      for(int i=0;i<PNum;i++)
         population[i]=new DNA(0,0);
      for(int i=0;i<SNum;i++)
         sons[i]=new DNA(0,0);
      for(int i=0;i<PNum;i++)
         Ttemp[i]=new DNA(0,0);

      CityGenerate();
    }
    
    //HI
    public void CityGenerate()
    {
       boolean check=false;
       int tx,ty,tsum;
       int di;
       city=new CityXY[PointNum];
       for(int i=0;i<PointNum;i++)
       {
          city[i]=new CityXY(0,0);
          do
	  {
	     check=true;

	     city[i].x=random(width-20)+10 ;
	     city[i].y=random(height-20)+10 ;
	     for(int j=0;j<i;j++)
	     {
                if(city[i].x==city[j].x&&city[i].y==city[j].y)
		{
		   check=false;
		   break;
		}
	     }
	  }while(check=false);
       }
      // constuct distance table
       for(int i=0;i<PointNum;i++)
       {
          distance[i][i]=0;
          for(int j=i+1;j<PointNum;j++)
	  {
	     tx=city[i].x-city[j].x;
	     ty=city[i].y-city[j].y;
	     tsum=tx*tx+ty*ty;
	     di=(int)((tx+ty)/2);
	     while(di*di<tsum)
	     {
	     	di++;
	     }
	     distance[i][j]=di;
	  }
       }
       for(int i=PointNum-1;i>=0;i--)
          for(int j=i-1;j>=0;j--)
	     distance[i][j]=distance[j][i];
    }
    
    //@²檺random function
    public int random(int t)
    {
       int x=r.nextInt()%t;
       if(x<0) x=-x;
       return x;
    }
    
    //Ĥ@B
    public void First()
    {
      //H
      for(int i=0; i<PNum ;i++ )
      {
         population[i].SortNum=0;
         population[i].DNACode[0]=0;
         population[i].DNACode[PointNum]=0;
         RandomPath(population[i].DNACode);
         population[i].SortNum=CountDist(population[i].DNACode);
      }
      //̸|Ƨ
      Sort(population,PNum);
      //̸|naMwfitness
      for(int i=0;i<PNum ; i++ )
         population[i].ChosenRank=(int)(1000000/population[i].SortNum);
   }
   
   //H|
   public void RandomPath(int Path[])
   {
      path a[]=new path[PointNum];
      for(int i=1;i<PointNum;i++)
      {
         a[i]=new path(0,0);
         a[i].Num=random(PointNum*PointNum)+1;
         a[i].path=i;
      }

      path temp=new path(0,0);
      int j;
      for(int i=2;i<PointNum;i++)
      {
         temp.Num=a[i].Num;
	 temp.path=a[i].path;
         for(j=i-1;j>0; j--)
	 {
	    if(temp.Num<=a[j].Num) break;
            a[j+1].Num=a[j].Num;
	    a[j+1].path=a[j].path;
	 }
         a[j+1].Num=temp.Num;
	 a[j+1].path=temp.path;
      }

      for(int i=1;i<PointNum;i++)
         Path[i]=a[i].path;

   }
   //p|
   public int  CountDist(int Path[])
   {
      int Ans=0;
      for(int i=0;i<PointNum;i++)
         Ans+=( distance[ Path[i] ][ Path[i+1] ] );

      return Ans;
   }
   //Ƨ
   void Sort(DNA  temp[],int n)
   {
      int i,j,k=n;
      DNA temp2=new DNA(0,0);
      for(k=(k+1)/3;k!=0;k=(k+1)/3 )
      {
         for(j=k;j<n;j++)
         {
           copy(temp2,temp[j]);
            for(i=j-k; i>=0 && temp2.SortNum<temp[i].SortNum ;i-=k )
               copy(temp[i+k],temp[i]);

            copy(temp[i+k],temp2);
         }
      }
   }
   //fitnessMwparent
   public int ChooseParent()
   {
      int a= random(1000000),i;
      for(i=0; i<PNum && population[i].ChosenRank< a ;a-=population[i].ChosenRank,i++);

      if (i==PNum) i=PNum-1;
      return i;
   }
   
   //t
   public void CrossOver()
   {
      int father,mother,a,b,echo,j;

      for(int n=0;n<(SNum/2);n++ )
      {
         a=2*n;
         b=a+1;

         father=ChooseParent();
         do{ mother=ChooseParent(); }
         while( mother==father );

         for(int i=1; i<PointNum ; i++ )
         {
            ftable[i]=-1;
            mtable[i]=-1;
         }

         sons[a].DNACode[0]=0;
         sons[a].DNACode[PointNum]=0;
         sons[b].DNACode[0]=0;
         sons[b].DNACode[PointNum]=0;

         for(int i=1;i<PointNum/2;i++)
         {
            sons[a].DNACode[i]=population[father].DNACode[i];
            sons[b].DNACode[i]=population[mother].DNACode[i];

            if( population[father].DNACode[i]!=population[mother].DNACode[i] )
            {
               ftable[population[father].DNACode[i] ]=population[mother].DNACode[i];
               mtable[population[mother].DNACode[i] ]=population[father].DNACode[i];
            }
         }

         for(int i=PointNum/2;i<PointNum;i++)
         {
            j=population[mother].DNACode[i];
            while( ftable[j]!=-1 )
            {   j=ftable[j];}
            sons[a].DNACode[i]=j;

            j=population[father].DNACode[i];
            while( mtable[j]!=-1 )
            {   j=mtable[j];}
            sons[b].DNACode[i]=j;
         }
	 Mutate(sons[a]);
         Mutate(sons[b]);


         sons[a].SortNum=CountDist(sons[a].DNACode);
         sons[b].SortNum=CountDist(sons[b].DNACode);

      }
      Select();
   }
   //
   public void Mutate(DNA  s)
   {
      int a,temp;
      for(int i=1;i<PointNum/2;i++)
      {
         if( random(100) > MRate )
            continue;
         do{
            a=random(PointNum-2)+1;
         }while(i==a);
         temp=s.DNACode[i];
         s.DNACode[i]=s.DNACode[a];
         s.DNACode[a]=temp;
      }
   }
   //Ѿ
   public void Select()
   {
   Sort( sons , SNum);

   int  n = PNum/2 + SNum/2;
   int hs = SNum/2;
   
   //lNe50%
   for(int i=0 ; i < SNum/2 ; i++ )
      copy(Ttemp[i], sons[i]);
   //˥Ne50%
   for(int i=0; i< PNum/2 ; i++ )
      copy(Ttemp[i+hs],population[i]);
   //aγѤU̮tɨ
   for(int i=n, s= (SNum-1), t=(PNum-1) ; i<PNum ; i++ )
   {
      if(sons[s].SortNum < population[t].SortNum )
      {
         copy(Ttemp[i],population[t]);
         t--;
      }
      else
      {
         copy(Ttemp[i],sons[s]);
         s--;
      }
   }

   //sort
   Sort(Ttemp,n);
   for(int i=0;i<PNum;i++)
   {
   	copy(population[i],Ttemp[i]);
   }
   for(int i=0;i<PNum ; i++ )
      population[i].ChosenRank=(int)(1000000/population[i].SortNum);

   }
   
   //⥭|
   public int Average()
   {
      int Ans=0;
      for(int i=0;i<PNum;i++)
         Ans+=population[i].SortNum;

      return Ans/PNum;
   }
}